#property indicator_separate_window
#property indicator_buffers 1

#property indicator_color1 Teal
#property indicator_minimum -1
#property indicator_maximum 1

extern int _PERIOD=9;
extern int _TF    =PERIOD_M5;

double _rci[], _rciB[];

string PeriodToStr(int period){
	string result="";
	switch(_TF){
	case PERIOD_D1:
		result="D1";
		break;
	case PERIOD_MN1:
		result="MN1";
		break;
	case PERIOD_W1:
		result="W1";
		break;
	case PERIOD_D1:
		result="D1";
		break;
	case PERIOD_H4:
		result="H4";
		break;
	case PERIOD_H1:
		result="H1";
		break;
	case PERIOD_M30:
		result="M30";
		break;
	case PERIOD_M15:
		result="M15";
		break;
	case PERIOD_M5:
		result="M5";
		break;
	case PERIOD_M1:
		result="M1";
		break;
	default:
		result="";
		break;
	}
	return (result);
}
int init(){
    if(_TF<Period())
    	_TF=Period();
	string tfs=PeriodToStr(_TF);
	if(tfs==""){
		tfs="Curr";
		_TF=0;
	}
	SetIndexLabel  (0, "RCI(" + _PERIOD + "," + tfs +")");
	SetIndexBuffer (0, _rci);
	IndicatorShortName("RCI(" + _PERIOD + "," + tfs +")");
	IndicatorDigits(4);
	return(0);
}

int deinit(){
	return(0);
}

int start(){
	int t,j;
	if(IndicatorCounted() < 0)
		return(-1);
    int a_tf=_TF;
    int limit = MathMax(1+a_tf/Period(), Bars - IndicatorCounted());

	double val[];
	ArrayResize(val,_PERIOD);
	/*	
	double q[];
	ArrayResize(q,_PERIOD);
	for(int j=0;j<_PERIOD;j++)
		q[j]=(j+1);
	double ma[2],stdev[2];
    ma[1] = iMAOnArray       (q,0,_PERIOD,0,MODE_SMA,0);
    stdev[1] = iStdDevOnArray(q,0,_PERIOD,0,MODE_SMA,0);
    */
	
	int y=0;
	for(t=0;t<limit;t++){
		if(Time[t]>=iTime(NULL,a_tf,y) && t>0){
			_rci[t]=_rci[t-1];
			continue;
		}
    	// Shift by a_tf
		while(Time[t]<iTime(NULL,a_tf,y)) {
			y++;
			if(y >= iBars(NULL,a_tf))
				break;
		}
	
		for(j=0;j<_PERIOD;j++)
			val[j]=iClose(NULL,a_tf,y+j);
		double sum=0;	
		for(int r=0;r<_PERIOD;r++){
			int max_idx=ArrayMaximum(val);
			sum += MathPow(max_idx-r,2);
			val[max_idx]=0;
		}
		_rci[t]=1-6*sum/(_PERIOD*(MathPow(_PERIOD,2)-1));
		
		// RCIb
		/*
	    ma[0]    = iMA    (NULL,0,_PERIOD,0,MODE_SMA,PRICE_CLOSE,t);
	    stdev[0] = iStdDev(NULL,0,_PERIOD,0,MODE_SMA,PRICE_CLOSE,t);
	    
	    double ma_dev_s=0;
	    for(int k=0;k<_PERIOD;k++) {
	    	ma_dev_s += (iClose(NULL,0,t+k)-ma[0]) * ((k+1)-ma[1]);
	    }
	    ma_dev_s /= _PERIOD;
	    _rci[t] = 0-(ma_dev_s/MathMax(0.00001, stdev[0]*stdev[1]));
	    */
	}
	return(0);
}

